/**
 * @class SparseCell
 * @brief implementing an output Method for Sparse Cells
 * @author Max Hadersbeck, based on Ideas from Florian Fink
 * *
 * defines a output methods, to print the content of an internal Sparse Cell
 *
 */


#include "sparse_cell.hpp"

/******************************************************************************/
        std::wostream& operator<<(std::wostream& out, const SparseCell& c)
        {
                switch (c.type) {
                case SparseCell::Empty:
                        out << "Empty";
                        break;
                case SparseCell::State:
                        out << "State";
                        out << " [" << c.offset << ", " << c.final << "]";
                        break;
                case SparseCell::Trans:
                        out << "Trans";
                        out << " [" << c.offset << ", " <<
                                c.target << ", " << c.label << "]";
                        break;
                default:
                         break;
                }
                return out;
        }
